#include "AdvancedOptionsView.h"
#include "messages.h"

#include <Box.h>
#include <CheckBox.h>
#include <StringView.h>
#include <TextControl.h>
#include <DirectWindow.h>

#include <cstdlib>

TAdvancedOptionsView::TAdvancedOptionsView(BRect rect)
	:
	BView(rect, "Advanced Options", B_FOLLOW_ALL, B_WILL_DRAW)
{
	BRect boxRect(10, 10, 230, 140);
	BBox *box = new BBox(boxRect, "Movie options");
	AddChild(box);
	box->SetLabel("Movie");
	
	BRect optionRect(5, 15, 200, 40);
	BStringView *framesLabel = new BStringView(optionRect, "framesLabel", "Frames per Second:");
	framesLabel->ResizeToPreferred();
	box->AddChild(framesLabel);
	
	optionRect.OffsetBy(0, 30);
	fRecordFPS = new BTextControl(optionRect, "recordFPS", "Record: ", "10", new BMessage());
	//fRecordFPS = new TFineControl(optionRect, "recordFPS", "Record: ", 10, new BMessage());
	fRecordFPS->ResizeToPreferred();
	
	optionRect.OffsetBy(0, 30);
	fPlayingFPS = new BTextControl(optionRect, "playFPS", "Play: ", "10",
		new BMessage(kFPSChanged));
	fPlayingFPS->ResizeTo(fRecordFPS->Frame().Width(), fRecordFPS->Frame().Height());
	fPlayingFPS->SetDivider(fRecordFPS->Divider());
	
	box->AddChild(fRecordFPS);
	box->AddChild(fPlayingFPS);
	
	BRect checkBoxRect(box->Frame().left, 175, 400, 200);
	fUseDirectWindow = new BCheckBox(checkBoxRect, "Use DW",
		"Use BDirectWindow (allows less CPU usage)", new BMessage());
	AddChild(fUseDirectWindow);
	fUseDirectWindow->ResizeToPreferred();
	
	if (static_cast<BDirectWindow *>(Window())->SupportsWindowMode()) {
		fUseDirectWindow->SetEnabled(true);
		fUseDirectWindow->SetValue(B_CONTROL_ON);
	} else
		fUseDirectWindow->SetEnabled(false);
}


void
TAdvancedOptionsView::AttachedToWindow()
{
	BView::AttachedToWindow();
	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
}


uint32
TAdvancedOptionsView::FramesPerSecond() const
{
	//return fRecordFPS->Value();
	return atoi(fRecordFPS->Text());
}


bool
TAdvancedOptionsView::UseDirectWindow() const
{
	return fUseDirectWindow->Value() == B_CONTROL_ON;
}
