#ifndef __OUTPUTVIEW_H
#define __OUTPUTVIEW_H

#include <MediaDefs.h>
#include <MediaFormats.h>
#include <View.h>

class BButton;
class BCheckBox;
class BMenuField;
class BOptionPopUp;
class BRadioButton;
class TRectView;
class BTextControl;
class TOutputView : public BView {
public:
	TOutputView(BRect rect);
	virtual void AttachedToWindow();
	virtual void MessageReceived(BMessage *message);
	
	void RebuildCodecMenu();
	
	BPath OutputFileName() const;
	bool IncludeCursor() const;
	
	void SetPlayingFPS(uint32 fps);
	bool MinimizeOnStart() const;
		
	void SetCaptureArea(BRect rect);
	BRect CaptureArea() const;
	
	media_format_family FormatFamily() const;
	media_format Format() const { return fFormat; };
	media_codec_info Codec() const;
			
private:
	BRect fCaptureArea;
	
	BTextControl *fFileName;	
	BOptionPopUp *fOutputFileType;
	
	BMenuField *fCodecMenu;
	BCheckBox *fMinimizeOnStart;
	
	uint32 fPlayingFPS;
	float fQuality;
	
	BButton *fSelectArea;
	BRadioButton *fWholeScreen;
	BRadioButton *fCustomArea;
	TRectView *fRectView;
	media_format fFormat;
	media_codec_info fCodecInfo;
		
	void SetAreaString(BRect);
	void BuildCodecMenu(media_format_family mf_family);
};


#endif
