#include "RectUtils.h"

#include <View.h>
#include <Window.h>

void
center_window_on_screen(BWindow *win, screen_id id)
{
	BScreen screen(id);
	if (!screen.IsValid())
		return;
		
	BRect screenFrame(screen.Frame());
	BRect winFrame(win->Frame());
	
	win->MoveTo((screenFrame.Width() - winFrame.Width()) / 2,
				(screenFrame.Height() - winFrame.Height()) / 2);
}


void
center_rect_on_screen(BRect &rect, screen_id id)
{
	BScreen screen(id);
	if (!screen.IsValid())
		return;
		
	BRect screenFrame(screen.Frame());
	
	rect.OffsetTo((screenFrame.Width() - rect.Width()) / 2,
				(screenFrame.Height() - rect.Height()) / 2);
}


void
center_rect_in_view(BRect &rect, BView *view)
{
	BRect viewBounds(view->Bounds());
	rect.OffsetTo((viewBounds.Width() - rect.Width()) / 2,
					(viewBounds.Height() - rect.Height()) / 2);
}
