#include "RectView.h"

#include <cstdio>

#include <Bitmap.h>
#include <Screen.h>

TRectView::TRectView(BRect rect)
	:
	BView(rect, "Rect View", B_FOLLOW_ALL, B_WILL_DRAW),
	fBitmap(NULL)
{
	fCoordRect = rect;
	fChanged = true;
}


void
TRectView::AttachedToWindow()
{	
	UpdateBitmap();
}


void
TRectView::Draw(BRect updateRect)
{
	//BRect sect = updateRect & Frame();
	BRect bounds(Bounds());
	
	SetHighColor(0, 0, 0);
	StrokeRect(bounds);
	
	SetDrawingMode(B_OP_INVERT);
	char str[32];
	snprintf(str, 32, "%.1f", fCoordRect.left); 
	BPoint left(bounds.LeftTop());
	left.x += 2;
	left.y += 5 + bounds.Height() / 2;	
	DrawString(str, left);
	
	snprintf(str, 32, "%.1f", fCoordRect.right); 
	BPoint right(left);
	right.x = bounds.Width() - StringWidth(str);
	DrawString(str, right);
	
	snprintf(str, 32, "%.1f", fCoordRect.top); 
	BPoint top(bounds.LeftTop());
	top.y += 9;
	top.x += bounds.Width() / 2 - StringWidth(str) / 2;
	DrawString(str, top);
	
	snprintf(str, 32, "%.1f", fCoordRect.bottom); 
	BPoint bottom(bounds.LeftTop());
	bottom.y += bounds.Height() - 1;
	bottom.x += bounds.Width() / 2 - StringWidth(str) / 2;
	DrawString(str, bottom);
}


void
TRectView::SetRect(BRect rect)
{
	fCoordRect = rect;
	fChanged = true;
	UpdateBitmap();
	Invalidate();
}


void
TRectView::UpdateBitmap()
{
	if (fChanged && Window() != NULL) {
		delete fBitmap;
		fChanged = false;
		BScreen screen(Window());
		screen.GetBitmap(&fBitmap, false, &fCoordRect);		
	}
	if (fBitmap != NULL)
		SetViewBitmap(fBitmap, fBitmap->Bounds(), Bounds());
}
